{    var   : }
{ N, F }
Unit MNP13_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNP11_p;

procedure MNP13(var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var G :Array of Real; var H :Array of Real;
                var RM :Array of Real; var UP :Array of Real);

implementation

procedure MNP13(var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var G :Array of Real; var H :Array of Real;
                var RM :Array of Real; var UP :Array of Real);
var
I,IN1,IN2,N1,N2,N3 :Integer;
FT :Real;
label
_10,_20;
begin
UP[0] := Power(0.1/FE,1.0/3.0);
RM[3] := FE;
FE := 0.1;
for I:=1 to N do
 begin
  UP[I+0] := Power(0.1/XE[I-1],1.0/3.0);
  RM[I+3] := XE[I-1];
  XE[I-1] := 0.1;
_10:
 end;
MNP11(N,H,X,G,F);
N1 := 4 + N;
N2 := 4 + 2*N;
N3 := 4 + 3*N;
for I:=1 to N do
 begin
  IN1 := I + N1;
  IN2 := I + N2;
  X[I-1] := X[I-1] + XE[I-1];
  MNP11(N,H,X,G,FT);
  X[I-1] := X[I-1] - XE[I-1];
  RM[IN1-1] := Sign(1.0,F-FT);
  RM[IN2-1] := Abs(F-FT)/FE*XE[I-1];
  if ( RM[IN2-1] >  UP[N+1] ) 
   then UP[N+1] := RM[IN2-1];
_20:
 end;
RM[1] := RM[1] + N + 1;
RM[0] := 0;
RM[N3+0] := 0;
RM[N3+1] := 0;
end;

end.
